local function pupil()
    push()
    move(0, -0.178, 0)
    push()
    size(0.095)
    move(0, -1, 0)
    make("ball")
    pop()
    pop()
end

local function eyeball()
    temp = color("white")
    push()
    size(0.165)
    move(0, -1, 0)
    make("ball")
    pop()
    color("black")
    pupil()
    color(temp)
end

local function eye(x)
    push()
    move(0.1916 * x, -0.3239, 0.5355)
    eyeball()
    pop()
end

local function _tusk()
    temp = color("white")
    push()
    size(0.09)
    move(0, -1, 0)
    make("ball")
    move(0, -2, 0)
    make("ball")
    move(0, -2, 0)
    make("ball")
    move(0, -2, 0)
    make("ball")
    move(0, -2, 0)
    make("ball")
    pop()
    color(temp)
end

local function tusk(x)
    push()
    move(0.2164 * x, -0.2304, 0.1548)
    _tusk()
    pop()
end

local function nose()
    push()
    move(0, -0.3804, 0.2764)
    push()
    size(0.175)
    move(0, -1, 0)
    make("ball")
    move(0, -2, 0)
    make("ball")
    move(0, -2, 0)
    make("ball")
    pop()
    pop()
end

local function ear(x)
    push()
    move(0.4018 * x, 0.1891, 0.6818)
    push()
    size(0.35)
    move(0, 0, 1)
    make("ball")
    pop()
    pop()
end

local function leg(x, y, t)
    push()
    move(0.2 * x, 0.2 * y, 0.1172)
    push()
    size(0.15)
    turn((1 + t) * 0.2 * y, 0, 0)
    move(0, 0, -1)
    make("ball")
    move(0, 0, -2)
    make("ball")
    pop()
    pop()
end

local function head(eye)
    push()
    move(0, -0.6087, 0.2022)
    push()
    size(0.4)
    move(0, 0, 1)
    make("ball")
    pop()
    ear(1)
    ear(-1)
    nose()
    tusk(1)
    tusk(-1)
    eye(1)
    eye(-1)
    pop()
end

local function tail(t)
    push()
    move(0, 0.3982, 0.4376)
    push()
    turn(0.1 * (1 + t), 0, 0)
    size(0.08)
    move(0, 0, -1)
    make("ball")
    move(0, 0, -2)
    make("ball")
    move(0, 0, -2)
    make("ball")
    move(0, 0, -2)
    make("ball")
    pop()
    pop()
end

local function body(t, eye)
    push()
    move(0, 0, 0)
    push()
    size(0.4)
    move(0, 0, 1)
    make("ball")
    pop()
    tail(t)
    head(eye)
    leg(1, 1, t)
    leg(-1, 1, t)
    leg(1, -1, t)
    leg(-1, -1, t)
    pop()
end

function graphics.allefant(t)
    color("yellow")
    move(0, 0, 0.5)
    body(t, eye)
end

function graphics.allefant_dead(t)
    color("yellow")
    move(0, 0, 0.6)
    turn(0, 1, 0)
    turn(0.3, 0, 0)
    body(0, function() end)
end

