
local ship = function(name, x)
    graphics[name] = function()
        turn(0.5, 0, 0)
        size(0.1)
        x()
    end
    classes.galaxy[name] = 1
    graphics[name .. ".animation"] = "static"
end

local shipc_body = function()
    push()
    turn(-.5, 0, 0)
    defer("sphere", 24, 16)
    deform(function(x, y, z)
        local a = math.atan2(x, z)
        local b = math.sin(a * 8)
        -- from kmplot: ±sqrt(1 − x ∙ x) ∙ (1.4 − ((1 + x) / 2)^2) ∙ 0.3
        local v = (1.4 - math.pow((1 - y) / 2, 2)) * 0.3
        x = x * v
        z = z * v
        b = b * (1 - math.abs(y) ^ 2)
        x = x * (1 + b * 0.1)
        z = z * (1 + b * 0.1)
        return x, y, z
    end, 3)
    vertex_color(function(x, y, z)
        local a = math.atan2(x, z)
        local b = math.sin(a * 8)
        b = b * (1 - math.abs(y) ^ 2)
        local c = (1 + b) / 2
        color("honeydew")
        fade("midnightblue", math.pow(1 - c, 4))
        r, g, b, a = rgba()
        return r, g, b, 1
    end)
    color("black")
    make()
    pop()
end

ship("shipc4", function()
    size(25)
    shipc_body()
    end)

