#ifndef _APPLICATION_
#define _APPLICATION_
typedef struct Application Application;
#include "world.h"
#include "script/model3d.h"
enum {
    LogNo,
    LogError,
    LogWarning,
    INFO,
    VERBOSE,
    LogDebug
};
#define DebugLogActor LogError
#define DebugLogTerrain LogError
#define DebugLogLua 0
#define DebugLuaScript 0
#define DebugLogModels 0
struct Application {
    World * world;
    bool debug_no_landscape;
    bool debug_no_units;
    bool debug_wireframe;
    bool debug_grid;
    bool debug_reveal_map;
    Camera cam;
    LandVector under;
    int ux, uy, ux_, uy_;
    bool can_build;
    int subdivisions;
    bool use_cache;
    int ticks;
    bool paused;
    bool warmup;
    bool done;
    Model3d * model_allefant;
    Model3d * model_mothership;
    Model3d * model_mark;
    Model3d * model_goal;
    LandSound * win;
    LandSound * yell;
    LandArray * units;
    Mesh * stars;
    LandVector starpos;
    LandVector light;
    bool music;
    LandStream * stream;
    int song;
    LandFont * font;
    int start_x, start_y;
    int goal_x, goal_y;
    int elephants;
    int released;
    int walls;
    int bridges;
    float zoom_to;
    int retrieved;
    int died;
    int level;
    int seed;
    bool first;
    bool release;
    int selection;
    bool show_help;
};
Application* app_global(void);
char* app_get_cache_path(str name);
#endif
