#ifndef _BRICK_
#define _BRICK_
typedef struct Brick Brick;
#include "main.h"
#include "game/camera.h"
#include "application.h"
enum {
    Nothing,
    Wall,
    Bridge,
    Mark,
    Goal
};
struct Brick {
    int x, y, z;
    int kind;
    LandVector p;
};
Brick* get_brick(int x, int y);
void add_brick(int kind, int x, int y);
void add_brick_offset(int kind, int x, int y, int z);
void add_brick_z(int kind, int x, int y, int z);
void del_brick(int x, int y);
void brick_draw_offset(Brick * b, Land4x4Matrix cm, Camera * cam, float ox, float oy);
void bricks_draw(Camera * cam, float ox, float oy);
void trans(Land4x4Matrix * t, Land4x4Matrix m);
void make_wall_hex(World * w);
void make_bridge_hex(World * w);
int check_pos(int x, int y, int z);
int check_wall_z(int x, int y, int z);
int check_bridge_z(int x, int y, int z);
int find_highest_z(int x, int y);
void build_bridge(float px, float py);
void clear_bricks(void);
#endif
