#include "common.h"
static LandArray * _funcs;
double rwrap(double x, double w) {
    // -w/2 .. w/2
    return x - (round(x / w)) * w;
}
double wrap(double x, double w) {
    // 0 .. w
    return x - (floor(x / w)) * w;
}
void common_add_cleanup(void(* cleanup)(void)) {
    if (! _funcs) {
        _funcs = land_array_new();
    }
    land_array_add(_funcs, cleanup);
}
void common_cleanup(void) {
    if (! _funcs) {
        return ;
    }
    {
        LandArrayIterator __iter0__ = LandArrayIterator_first(_funcs);
        for (void * func = LandArrayIterator_item(_funcs, &__iter0__); LandArrayIterator_next(_funcs, &__iter0__); func = LandArrayIterator_item(_funcs, &__iter0__)) {
            ((void(*)(void)) func)();
        }
    }
    land_array_destroy(_funcs);
    _funcs = NULL;
}
