#ifndef _GAME_CAMERA_
#define _GAME_CAMERA_
typedef struct Camera Camera;
#include "common.h"
#define Vector LandVector
struct Camera {
    Vector p, x, y, z;
    LandFloat zoom;
};
char* camera_to_string(Camera * self);
void camera_from_string(Camera * self, char const * s);
Camera* camera_new(void);
void camera_init(Camera * c);
Camera camera_identity(void);
void camera_change_freely(Camera * self, float x, float y, float z);
void camera_change_locked(Camera * self, float x, float z);
void camera_change_locked_constrained(Camera * self, float x, float z, float min_x, float max_x);
LandFloat camera_get_pitch(Camera * self);
LandFloat camera_get_roll(Camera * self);
LandFloat camera_get_yaw(Camera * self);
void camera_set_yaw(Camera * self, LandFloat a);
void camera_move(Camera * self, float x, float y, float z);
void camera_shift(Camera * self, float x, float y);
void camera_look_into(Camera * self, float dx, float dy);
void camera_warp(Camera * self, float x, float y, float z);
Land4x4Matrix camera_matrix(Camera * camera);
LandFloat camera_get_scale(Camera * camera);
Land4x4Matrix camera_forward_matrix(Camera * camera);
Land4x4Matrix camera_forward_matrix_replace_position(Camera * camera, LandVector * pos);
void camera_init_from_matrix(Camera * camera, Land4x4Matrix matrix);
LandVector camera_get_on_screen_position(Camera * cam, LandVector pos);
void camera_tests(void);
#endif
