#ifndef _GAME_MODEL_
#define _GAME_MODEL_
typedef struct ModelRender ModelRender;
#include "main.h"
#include "camera.h"
#include "mesh.h"
#include "world.h"
#include "render.h"
struct ModelRender {
    LandGLSLShader * shader;
    GLint xyz, uv, normal, rgba, tex;
    GLint wireframe, invisibility;
    int recreate_tick /* timestamp when we were recreated */;
};
ModelRender* model_render_singleton(void);
void model_set_glsl(str vertex, str fragment, str name);
void model_render_object(Mesh * mesh, Land4x4Matrix matrix, Camera * cam);
void model_render_object_light(Mesh * mesh, Land4x4Matrix matrix, Camera * cam, LandVector light);
void model_render_object_light2(Mesh * mesh, Land4x4Matrix matrix, Land4x4Matrix projection, Camera * cam, LandVector light);
void model_render_object_light3(Mesh * mesh, Land4x4Matrix matrix, Land4x4Matrix projection, Camera * cam, LandVector light, float alpha);
void model_render_done(void);
#endif
