#include "script/model3d.h"
Model3d* model3d_new(str name) {
    Model3d * self;
    land_alloc(self);
    self->name = land_strdup(name);
    self->scale = 1;
    return self;
}
void model3d_destroy(Model3d * self) {
    if (self->frames) {
        {
            LandArrayIterator __iter0__ = LandArrayIterator_first(self->frames);
            for (Mesh * mesh = LandArrayIterator_item(self->frames, &__iter0__); LandArrayIterator_next(self->frames, &__iter0__); mesh = LandArrayIterator_item(self->frames, &__iter0__)) {
                if (mesh) {
                    mesh_destroy(mesh);
                }
            }
        }
        land_array_destroy(self->frames);
    }
    land_free(self->name);
    land_free(self);
}
Mesh* model3d_get_mesh(Model3d * self, int frame) {
    return land_array_get_nth(self->frames, frame);
}
