#ifndef _SCRIPT_SCRIPT_
#define _SCRIPT_SCRIPT_
#include <lua.h>
#include <lauxlib.h>
#include <lualib.h>
typedef struct PerThread PerThread;
#include "common.h"
#include "application.h"
extern lua_State * script_L;
struct PerThread {
    lua_State * l;
    lua_Debug debug;
    LandHash * loaded_scripts_hash /* Script */;
    LandArray * loaded_scripts_order;
    LandHash * registered_functions /* void* */;
};
lua_State* script_init(void);
void script_init_new(PerThread * pt);
lua_State* script_init_thread(int tid);
lua_Debug* script_debug_info(lua_State * l);
PerThread* script_get_per_thread(lua_State * l);
void script_cleanup(void);
void script_reload(lua_State * l, char const * name);
void script_error(char const * format, ...);
LandArray* script_get_errors(void);
void script_clear_errors(void);
bool script_load(lua_State * L, char const * name);
void script_unload(lua_State * L, char const * name);
void script_register_same_functions_as(lua_State * l, lua_State * las);
void script_load_same_files_as(lua_State * l, lua_State * las);
bool script_with_code(lua_State * L, str name, str code);
void script_execute(lua_State * L, str name);
void script_execute_params(lua_State * L, str name, int params);
void script_debug(lua_State * L, int ind);
bool script_debug_repeat(lua_State * L, LandArray * path, int repeat, char * key, char * val);
void script_startup(void);
#endif
