#ifndef _UNIT_
#define _UNIT_
typedef struct Unit Unit;
#include "main.h"
#include "application.h"
#include "game/camera.h"
#include "script/model3d.h"
enum {
    UnitNone,
    UnitAllefant,
    UnitMothership
};
struct Unit {
    int kind;
    Camera cam;
    LandVector start;
    float transition_time;
    float speed;
    float visible, visible_want;
    bool left;
    bool fall;
    bool bridge;
    bool walk;
    bool dead;
    LandVector drift;
    int counter;
};
Unit* unit_new(int kind, float x, float y);
void units_clear(void);
void units_tick(void);
void catch(Unit * self);
void unit_plan(Unit * self);
void unit_fly(Unit * self);
void unit_tick(Unit * self);
void units_draw_offset(float ox, float oy);
void unit_draw(Unit * self, LandVector light);
void draw_model(Model3d * c, Camera * cam, float alpha, LandVector light);
#endif
