#ifndef _WORLD_
#define _WORLD_
typedef struct World World;
#include "main.h"
#include "game/camera.h"
#include "game/mesh.h"
#include "game/landscape.h"
#include "game/model.h"
#include "application.h"
#include "unit.h"
#include "brick.h"
struct World {
    double t;
    Landscape * landscape;
    LandArray * bricks;
    int s;
    uint8_t * bricks_map;
    Mesh * wall [8];
    Mesh * bridge;
};
void pos_to_hex(float px, float py, int * hx, int * hy);
void hex_to_int(int hx, int hy, int * ix, int * iy);
void add_dir(int * x, int * y, int d);
int get_hex_dir(float dx, float dy);
float get_top_z(int x, int y);
Land4x4Matrix world_get_projection_matrix(void);
int world_width(void);
void world_render(World * self, Camera * cam);
World* world_new_with_landscape(Landscape * ls);
void create_map(Landscape * self, int seed);
World* world_new(void);
void level(void);
void world_destroy(World * self);
LandVector world_get_position_under_z(Camera * c, float mx, float my);
#endif
